
#include <avr/io.h>
#include "HDSP2000.h"


unsigned char HDSP2000_Digits[HDSP2000_DIGITS]={0x00,0x00,0x00,0x00,
                                                0x00,0x00,0x00,0x00};

//hdsp2000 char set
unsigned char HDSP2000_CharSet[20][5]={0x3E,0x45,0x49,0x51,0x3E,    //0
                                       0x00,0x10,0x20,0x7F,0x00,
                                       0x21,0x43,0x45,0x49,0x31,
                                       0x22,0x41,0x41,0x49,0x36,

                                       0x08,0x18,0x28,0x7F,0x08,
                                       0x79,0x49,0x49,0x49,0x46,
                                       0x3E,0x49,0x49,0x49,0x26,
                                       0x43,0x44,0x48,0x50,0x60,

                                       0x36,0x49,0x49,0x49,0x36,
                                       0x32,0x49,0x49,0x49,0x3E,
                                       0x3F,0x44,0x44,0x44,0x3F,    //A
                                       0x7F,0x49,0x49,0x49,0x36,

                                       0x3E,0x41,0x41,0x41,0x22,
                                       0x7F,0x41,0x41,0x41,0x3E,
                                       0x7F,0x49,0x49,0x41,0x41,
                                       0x7F,0x48,0x48,0x40,0x40, 
 
                                       0x00,0x36,0x36,0x00,0x00,    //:
                                       0x00,0x00,0x00,0x00,0x00,
                                       0x00,0x00,0x00,0x00,0x00,
                                       0x00,0x00,0x00,0x00,0x00};
//init function
void HDSP2000_Init(void)
{
    HDSP2000_CLK_OFF;
    HDSP2000_DIN_OFF;

    HDSP2000_C1_OFF;
    HDSP2000_C2_OFF;
    HDSP2000_C3_OFF;
    HDSP2000_C4_OFF;
    HDSP2000_C5_OFF;


    HDSP2000_CLK_OUT;
    HDSP2000_DIN_OUT;

    HDSP2000_C1_OUT;
    HDSP2000_C2_OUT;
    HDSP2000_C3_OUT;
    HDSP2000_C4_OUT;
    HDSP2000_C5_OUT;
}
//basic function for hdsp2000 register access (fill 7 bits to reg)
void HDSP2000_SendColumn (unsigned char col)
{
    unsigned char cnt=HDSP2000_NUMB_OF_COL;
    while(cnt)
    {
        HDSP2000_CLK_ON;
        if(col&0x01)
        {
            HDSP2000_DIN_ON;
        }
        col>>=1;
        HDSP2000_CLK_OFF;
        HDSP2000_DIN_OFF;
        cnt--;
    }
}
//update display function (must allways be recalled) for example in interrupt
void HDSP2000_Update (void)
{
    static unsigned char Row=0x00;
    unsigned char digit=0;


    if(Row==HDSP2000_NUMB_OF_ROW)
            Row=0;

    //switch off all rows
    HDSP2000_C1_OFF;
    HDSP2000_C2_OFF;
    HDSP2000_C3_OFF;
    HDSP2000_C4_OFF;
    HDSP2000_C5_OFF;

    //get asci info from char set ans fill it into teh display
    digit=0;
    while(digit<HDSP2000_DIGITS)   
    {
        HDSP2000_SendColumn(HDSP2000_CharSet[HDSP2000_Digits[digit]][Row]);
        digit++;
    }

    //switch on next row
    switch(Row)
    {
        case 0:
        {
            HDSP2000_C1_ON;
            break;
        }
        case 1:
        {
            HDSP2000_C2_ON;
            break;
        }
        case 2:
        {
            HDSP2000_C3_ON;
            break;
        }
        case 3:
        {
            HDSP2000_C4_ON;
            break;
        }
        case 4:
        {
            HDSP2000_C5_ON;
            break;
        }
    }
    Row++;

}


