  
#include "Fdf.h"

#ifndef HDSP2000_HEADER
#define HDSP2000_HEADER

/*****************************************************************************/
/*general for HDSP2000                                                       */
/*****************************************************************************/

#define HDSP2000_PINON          PRZ_PINSET
#define HDSP2000_PINOFF         PRZ_PINRESET
#define HDSP2000_PINISON        PRZ_PINISSET
#define HDSP2000_PINISOFF       PRZ_PINISRESET


#define HDSP2000_NUMB_OF_DISP   2   //if change - change field init from digit field HDSP2000_Digits
#define HDSP2000_NUMB_OF_DIG    4   //dont change (one display allways has 4 digits)
#define HDSP2000_NUMB_OF_COL    7   //dont change (one digit allways has 7 rows)
#define HDSP2000_NUMB_OF_ROW    5   //dont change (one digit allways has 5 columns)

#define HDSP2000_DIGITS         HDSP2000_NUMB_OF_DISP*HDSP2000_NUMB_OF_DIG


/*****************************************************************************/
/* display */
/*****************************************************************************/
/*



                  ` ` ` ` ` ` ` ` ` ` ` ` ` `
                  || || || || || || || || || || || || || ||
                  || || || || || || || || || || || || || ||
                  || || || || || || || || || || || || || ||
                  || || || || || || || || || || || || || ||
                 .--.--.--.--.--.--.--.--.--.--.--.--.--.--.
                 |--|--|--|--|--|--|--|--|--|--|--|--|--|--|
           .-----------------------------------------------------.
           |() () () () () () () () () () () () () () () () () ()|
	       |  .--.--.--.--.--.--.--.--.--.--.--.--.--.--.--.--.  |
           |()|  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |()|
           |  .--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--.  |
           |()|  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |()|
	       |  .--+--'--'--'--'--'--'--'--'--'--'--'--'--'--+--.  |
           |()|  |() () () () () () () () () () () () () ()|  |()|
           |  .--+--.--.--.--.--.--.--.--.--.--.--.--.--.--+--.  |
           |()|  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |()|
	       |  .--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--.  |
           |()|  |  |11|14|12|16|17|20|  |20|15|13|18|19|  |  |()|
           |  .--+--'--'--'--'--'--'--'--'--'--'--'--'--'--+--.  |
           |()|  |() () () () () () () () () () () () () ()|  |()|
           |  .--.                                         .--.  |
           |()|  |() () () () () () () () () () () () () ()|  |()|
           |  .--+--.--.--.--.--.--.--.--.--.--.--.--.--.--+--.  |
           |()|  |  |++ ++ ++ ++ ++ ++|  |++ ++ ++ ++ ++ ++|  |()|
           |  .--+-.-------------------..-------------------.-.  |
           |()|  |(|...  ...   ...  ...||...  ...   ...  ...| |()|
           |  .--. |:::  :::   :::  :::||:::  :::   :::  :::|-.  |
           |()|  |(|:::  :::   :::  :::||:::  :::   :::  :::| |()|
           |  .--+-'-------------------''-------------------'-.  |
           |()|  |  |++ ++ ++ ++ ++ ++|  |++ ++ ++ ++ ++ ++|  |()|
           |  .--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--.  |
           |()|  |  | 1| 3| 5| 7| 9|  |  | 2| 4| 6| 8|10|  |  |()|
           |  .--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--.  |
           |()|  |  |  |  |  |  |  |  |  |  |  |  |  |  |  |19|()|
           |  .--+--'--'--'--'--'--'--'--'--'--'--'--'--'--+--.  |
           |()|  |() () () () () () () () () () () () () ()|18|()|
           |  .--+--.--.--.--.--.--.--.--.--.--.--.--.--.--+--.  |
           |()|15|  |  |  |  |13|  |  |  |  |10| 8| 6| 4| 2|17|()| 
           |  .--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--.  |
           |()|14|  |  |  |  |12|11|  |  |  | 9| 7| 5| 3| 1|16|()|
           |  '--'--'--'--'--'--'--'--'--'--'--'--'--'--'--'--'  |
           |() () () () () () () () () () () () () () () () () ()|
           |     .-----------------------------------------.     |
           |() ()|  |  |  |  |  |  |  |  |  |  |  |  |  |  |() ()|
           |     |  |  |  |  |  |  |  |  |  |  |  |  |  |  |     |
           |() ()|  |  |  |  |  |  |  |  |  |  |  |  |  |  |() ()|
           |     |  |  |  |  |  |  |  |  |  |  |  |  |  |  |     |
           |() ()|  |  |  |  |  |  |  |  |  |  |  |  |  |  |() ()|
           |     |-----------------------------------------|     |
           |() ()| - 5v      ClkDin          C5 C4 C3 C2 C1|() ()|
           |     |                                         |     |
           '-----'                                         '-----'




                                  VCC                        VCC
                                  | |                        | |
           .--------+-------------)-)----------.             | |
           |        10            8 9          10            8 9
           |      .-+-------------+-+--.     .-+-------------+-+--.
           |      | ...  ...  ...  ... |     | ...  ...  ...  ... |
           |      | :::  :::  :::  ::: |     | :::  :::  :::  ::: |
           |   .--+ :::  :::  :::  ::: +-----+ :::  :::  :::  ::: +
           |   |12|      HDSP2000      |7  12|      HDSP2000      |7
           |   |  '-+--+--+--+--+---+--'     '-+--+--+--+--+---+--'
           |   |    1  2  3  4  5   11         1  2  3  4  5   11
           |   |    |  |  |  |  |   |          |  |  |  |  |   |
           |   |    |  |  |  |  |  GND         |  |  |  |  |  GND
           |   |    +--)--)--)--)--------------'  |  |  |  | 
           |   |    |  +--)--)--)-----------------'  |  |  |
           |   |    |  |  +--)--)--------------------'  |  |
           |   |    |  |  |  +--)-----------------------'  |
           |   |    |  |  |  |  +--------------------------'
           |   |    |  |  |  |  |  
           |   |  .-+--+--+--+--+--+-.
           |   |  |                  |
           |   |  |     UDN2981      | (An 3,6V)
           |   |  |  oder 5x 32ohm   |
           |   |  '-+--+--+--+--+--+-'
           |   |    |  |  |  |  |   GND     
          CLK DIN  C1 C2 C3 C4 C5
 




//Zeichensatz


void HDSP2000_Init (void)
{
}

void HDSP2000_SetDigit (unsigned char Asci,unsigend char place)
{
}

void HDSP2000_SendString (unsigned char * String)
{
}


             
*/
/*****************/
/* Port defines  */
/*****************/

//CLOCK
#define HDSP2000_CLKDIRREG    DDRB
#define HDSP2000_CLKOUTREG    PORTB
#define HDSP2000_CLKINREG     PINB
#define HDSP2000_CLK          1
//DATAIN
#define HDSP2000_DINDIRREG    DDRB
#define HDSP2000_DINOUTREG    PORTB
#define HDSP2000_DININREG     PINB
#define HDSP2000_DIN          0
//COLUMN1
#define HDSP2000_C1DIRREG     DDRC
#define HDSP2000_C1OUTREG     PORTC
#define HDSP2000_C1INREG      PINC
#define HDSP2000_C1           2
//COLUMN2
#define HDSP2000_C2DIRREG     DDRC
#define HDSP2000_C2OUTREG     PORTC
#define HDSP2000_C2INREG      PINC
#define HDSP2000_C2           3
//COLUMN3
#define HDSP2000_C3DIRREG     DDRC
#define HDSP2000_C3OUTREG     PORTC
#define HDSP2000_C3INREG      PINC
#define HDSP2000_C3           4
//COLUMN4
#define HDSP2000_C4DIRREG     DDRC
#define HDSP2000_C4OUTREG     PORTC
#define HDSP2000_C4INREG      PINC
#define HDSP2000_C4           5
//COLUMN5
#define HDSP2000_C5DIRREG     DDRD
#define HDSP2000_C5OUTREG     PORTD
#define HDSP2000_C5INREG      PIND
#define HDSP2000_C5           4




/*****************************************************************************/
/*Used defines*/
/*****************************************************************************/

/*      example:                                DDRC  |= (1<<4)
                                                ----  --     -
                                                 /     |      \
                                               /       |        \
                                             /         |          \
                                           /           |            \
                                          |            |             |
                                          V            V             V
*/
/**************/
/*            */
/**************/


#define HDSP2000_CLK_ON        HDSP2000_CLKOUTREG   HDSP2000_PINON      (1<<HDSP2000_CLK)
#define HDSP2000_CLK_OFF       HDSP2000_CLKOUTREG   HDSP2000_PINOFF     (1<<HDSP2000_CLK)
#define HDSP2000_CLK_IN        HDSP2000_CLKDIRREG   PRZ_DIRIN           (1<<HDSP2000_CLK)
#define HDSP2000_CLK_OUT       HDSP2000_CLKDIRREG   PRZ_DIROUT          (1<<HDSP2000_CLK)
 
#define HDSP2000_CLK_ISON      (1<<HDSP2000_CLK)    HDSP2000_PINISON     HDSP2000_CLKINREG
#define HDSP2000_CLK_ISOFF     (1<<HDSP2000_CLK)    HDSP2000_PINISOFF    HDSP2000_CLKINREG
#define HDSP2000_CLK_ISIN      (1<<HDSP2000_CLK)    PRZ_DIRISIN          HDSP2000_CLKDIRREG     
#define HDSP2000_CLK_ISOUT     (1<<HDSP2000_CLK)    PRZ_DIRISOUT         HDSP2000_CLKDIRREG 


#define HDSP2000_DIN_ON        HDSP2000_DINOUTREG   HDSP2000_PINON      (1<<HDSP2000_DIN)
#define HDSP2000_DIN_OFF       HDSP2000_DINOUTREG   HDSP2000_PINOFF     (1<<HDSP2000_DIN)
#define HDSP2000_DIN_IN        HDSP2000_DINDIRREG   PRZ_DIRIN           (1<<HDSP2000_DIN)
#define HDSP2000_DIN_OUT       HDSP2000_DINDIRREG   PRZ_DIROUT          (1<<HDSP2000_DIN)
 
#define HDSP2000_DIN_ISON      (1<<HDSP2000_DIN)    HDSP2000_PINISON     HDSP2000_DININREG
#define HDSP2000_DIN_ISOFF     (1<<HDSP2000_DIN)    HDSP2000_PINISOFF    HDSP2000_DININREG
#define HDSP2000_DIN_ISIN      (1<<HDSP2000_DIN)    PRZ_DIRISIN          HDSP2000_DINDIRREG 
#define HDSP2000_DIN_ISOUT     (1<<HDSP2000_DIN)    PRZ_DIRISOUT         HDSP2000_DINDIRREG 


#define HDSP2000_C1_ON         HDSP2000_C1OUTREG    HDSP2000_PINON      (1<<HDSP2000_C1)
#define HDSP2000_C1_OFF        HDSP2000_C1OUTREG    HDSP2000_PINOFF     (1<<HDSP2000_C1)
#define HDSP2000_C1_IN         HDSP2000_C1DIRREG    PRZ_DIRIN           (1<<HDSP2000_C1)
#define HDSP2000_C1_OUT        HDSP2000_C1DIRREG    PRZ_DIROUT          (1<<HDSP2000_C1)
 
#define HDSP2000_C1_ISON       (1<<HDSP2000_C1)     HDSP2000_PINISON     HDSP2000_C1INREG
#define HDSP2000_C1_ISOFF      (1<<HDSP2000_C1)     HDSP2000_PINISOFF    HDSP2000_C1INREG
#define HDSP2000_C1_ISIN       (1<<HDSP2000_C1)     PRZ_DIRISIN          HDSP2000_C1DIRREG     
#define HDSP2000_C1_ISOUT      (1<<HDSP2000_C1)     PRZ_DIRISOUT         HDSP2000_C1DIRREG 


#define HDSP2000_C2_ON         HDSP2000_C2OUTREG    HDSP2000_PINON      (1<<HDSP2000_C2)
#define HDSP2000_C2_OFF        HDSP2000_C2OUTREG    HDSP2000_PINOFF     (1<<HDSP2000_C2)
#define HDSP2000_C2_IN         HDSP2000_C2DIRREG    PRZ_DIRIN           (1<<HDSP2000_C2)
#define HDSP2000_C2_OUT        HDSP2000_C2DIRREG    PRZ_DIROUT          (1<<HDSP2000_C2)
 
#define HDSP2000_C2_ISON       (1<<HDSP2000_C2)     HDSP2000_PINISON     HDSP2000_C2INREG
#define HDSP2000_C2_ISOFF      (1<<HDSP2000_C2)     HDSP2000_PINISOFF    HDSP2000_C2INREG
#define HDSP2000_C2_ISIN       (1<<HDSP2000_C2)     PRZ_DIRISIN          HDSP2000_C2DIRREG     
#define HDSP2000_C2_ISOUT      (1<<HDSP2000_C2)     PRZ_DIRISOUT         HDSP2000_C2DIRREG 


#define HDSP2000_C3_ON         HDSP2000_C3OUTREG    HDSP2000_PINON      (1<<HDSP2000_C3)
#define HDSP2000_C3_OFF        HDSP2000_C3OUTREG    HDSP2000_PINOFF     (1<<HDSP2000_C3)
#define HDSP2000_C3_IN         HDSP2000_C3DIRREG    PRZ_DIRIN           (1<<HDSP2000_C3)
#define HDSP2000_C3_OUT        HDSP2000_C3DIRREG    PRZ_DIROUT          (1<<HDSP2000_C3)
 
#define HDSP2000_C3_ISON       (1<<HDSP2000_C3)     HDSP2000_PINISON     HDSP2000_C3INREG
#define HDSP2000_C3_ISOFF      (1<<HDSP2000_C3)     HDSP2000_PINISOFF    HDSP2000_C3INREG
#define HDSP2000_C3_ISIN       (1<<HDSP2000_C3)     PRZ_DIRISIN          HDSP2000_C3DIRREG     
#define HDSP2000_C3_ISOUT      (1<<HDSP2000_C3)     PRZ_DIRISOUT         HDSP2000_C3DIRREG 


#define HDSP2000_C4_ON         HDSP2000_C4OUTREG    HDSP2000_PINON      (1<<HDSP2000_C4)
#define HDSP2000_C4_OFF        HDSP2000_C4OUTREG    HDSP2000_PINOFF     (1<<HDSP2000_C4)
#define HDSP2000_C4_IN         HDSP2000_C4DIRREG    PRZ_DIRIN           (1<<HDSP2000_C4)
#define HDSP2000_C4_OUT        HDSP2000_C4DIRREG    PRZ_DIROUT          (1<<HDSP2000_C4)
 
#define HDSP2000_C4_ISON       (1<<HDSP2000_C4)     HDSP2000_PINISON     HDSP2000_C4INREG
#define HDSP2000_C4_ISOFF      (1<<HDSP2000_C4)     HDSP2000_PINISOFF    HDSP2000_C4INREG
#define HDSP2000_C4_ISIN       (1<<HDSP2000_C4)     PRZ_DIRISIN          HDSP2000_C4DIRREG     
#define HDSP2000_C4_ISOUT      (1<<HDSP2000_C4)     PRZ_DIRISOUT         HDSP2000_C4DIRREG 


#define HDSP2000_C5_ON         HDSP2000_C5OUTREG    HDSP2000_PINON      (1<<HDSP2000_C5)
#define HDSP2000_C5_OFF        HDSP2000_C5OUTREG    HDSP2000_PINOFF     (1<<HDSP2000_C5)
#define HDSP2000_C5_IN         HDSP2000_C5DIRREG    PRZ_DIRIN           (1<<HDSP2000_C5)
#define HDSP2000_C5_OUT        HDSP2000_C5DIRREG    PRZ_DIROUT          (1<<HDSP2000_C5)
 
#define HDSP2000_C5_ISON       (1<<HDSP2000_C5)     HDSP2000_PINISON     HDSP2000_C5INREG
#define HDSP2000_C5_ISOFF      (1<<HDSP2000_C5)     HDSP2000_PINISOFF    HDSP2000_C5INREG
#define HDSP2000_C5_ISIN       (1<<HDSP2000_C5)     PRZ_DIRISIN          HDSP2000_C5DIRREG     
#define HDSP2000_C5_ISOUT      (1<<HDSP2000_C5)     PRZ_DIRISOUT         HDSP2000_C5DIRREG 


extern unsigned char HDSP2000_Digits[HDSP2000_DIGITS];
//prototypes
void HDSP2000_Init(void);
void HDSP2000_Update (void);


#endif































































































