#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>

#define F_CPU 1000000UL
#include <util/delay.h>

#include "HDSP2000.h"


void HDSP2000_SendColumn (unsigned char col)
{
    unsigned char i=7;
    while(i)
    {
        HDSP2000_CLK_ON;
        if(col&0x01)
        {
            HDSP2000_DIN_ON;
        }
        col>>=1;
        HDSP2000_CLK_OFF;
        HDSP2000_DIN_OFF;
        i--;
    }
}
void HDSP2000_SendCompColumn (unsigned char col)
{
    unsigned char i=HDSP2000_DIGITS;
    while(i)
    {
        HDSP2000_SendColumn(col);
        i--;
    }
}

int main (void)
{
    HDSP2000_CLK_OFF;
    HDSP2000_DIN_OFF;

    HDSP2000_C1_OFF;
    HDSP2000_C2_OFF;
    HDSP2000_C3_OFF;
    HDSP2000_C4_OFF;
    HDSP2000_C5_OFF;


    HDSP2000_CLK_OUT;
    HDSP2000_DIN_OUT;

    HDSP2000_C1_OUT;
    HDSP2000_C2_OUT;
    HDSP2000_C3_OUT;
    HDSP2000_C4_OUT;
    HDSP2000_C5_OUT;




	while(1)
	{
        HDSP2000_SendCompColumn(0x3E);
        HDSP2000_C1_ON;
	    _delay_ms(1);
        HDSP2000_C1_OFF;

        HDSP2000_SendCompColumn(0x41);
        HDSP2000_C2_ON;
	    _delay_ms(1);
        HDSP2000_C2_OFF;

        HDSP2000_SendCompColumn(0x41);
        HDSP2000_C3_ON;
	    _delay_ms(1);
        HDSP2000_C3_OFF;

        HDSP2000_SendCompColumn(0x41);
        HDSP2000_C4_ON;
	    _delay_ms(1);
        HDSP2000_C4_OFF;

        HDSP2000_SendCompColumn(0x3e);
        HDSP2000_C5_ON;
	    _delay_ms(1);
        HDSP2000_C5_OFF;

	}
}
