#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>

#define F_CPU 1000000UL
#include <util/delay.h>

#include "HDSP2000.h"

unsigned char HDSP2000_CharSet[20][5]={0x3E,0x45,0x49,0x51,0x3E,    //0
                                       0x00,0x10,0x20,0xEF,0x00,
                                       0x21,0x43,0x45,0x49,0x31,
                                       0x22,0x41,0x41,0x49,0x36,

                                       0x08,0x18,0x28,0x7F,0x08,
                                       0x79,0x49,0x49,0x49,0x46,
                                       0x3E,0x49,0x49,0x49,0x26,
                                       0x43,0x44,0x48,0x50,0x60,

                                       0x36,0x49,0x49,0x49,0x36,
                                       0x32,0x49,0x49,0x49,0x3E,
                                       0x3F,0x44,0x44,0x44,0x3F,    //A
                                       0x7F,0x49,0x49,0x49,0x36,

                                       0x3E,0x41,0x41,0x41,0x22,
                                       0x7F,0x41,0x41,0x41,0x3E,
                                       0x7F,0x49,0x49,0x41,0x41,
                                       0x7F,0x48,0x48,0x40,0x40, 
 
                                       0x00,0x00,0x00,0x00,0x00,
                                       0x00,0x00,0x00,0x00,0x00,
                                       0x00,0x00,0x00,0x00,0x00,
                                       0x00,0x00,0x00,0x00,0x00};

void HDSP2000_SendColumn (unsigned char col)
{
    unsigned char i=7;
    while(i)
    {
        HDSP2000_CLK_ON;
        if(col&0x01)
        {
            HDSP2000_DIN_ON;
        }
        col>>=1;
        HDSP2000_CLK_OFF;
        HDSP2000_DIN_OFF;
        i--;
    }
}
void HDSP2000_SendCompColumn (unsigned char col)
{
    unsigned char i=HDSP2000_DIGITS;
    while(i)
    {
        HDSP2000_SendColumn(col);
        i--;
    }
}

int main (void)
{
    unsigned char asci=0;

    unsigned int run=0;

    HDSP2000_CLK_OFF;
    HDSP2000_DIN_OFF;

    HDSP2000_C1_OFF;
    HDSP2000_C2_OFF;
    HDSP2000_C3_OFF;
    HDSP2000_C4_OFF;
    HDSP2000_C5_OFF;


    HDSP2000_CLK_OUT;
    HDSP2000_DIN_OUT;

    HDSP2000_C1_OUT;
    HDSP2000_C2_OUT;
    HDSP2000_C3_OUT;
    HDSP2000_C4_OUT;
    HDSP2000_C5_OUT;


	while(1)
	{
        HDSP2000_SendCompColumn(HDSP2000_CharSet[asci][0]);
        HDSP2000_C1_ON;
	    _delay_ms(1);
        HDSP2000_C1_OFF;

        HDSP2000_SendCompColumn(HDSP2000_CharSet[asci][1]);
        HDSP2000_C2_ON;
	    _delay_ms(1);
        HDSP2000_C2_OFF;

        HDSP2000_SendCompColumn(HDSP2000_CharSet[asci][2]);
        HDSP2000_C3_ON;
	    _delay_ms(1);
        HDSP2000_C3_OFF;

        HDSP2000_SendCompColumn(HDSP2000_CharSet[asci][3]);
        HDSP2000_C4_ON;
	    _delay_ms(1);
        HDSP2000_C4_OFF;

        HDSP2000_SendCompColumn(HDSP2000_CharSet[asci][4]);
        HDSP2000_C5_ON;
	    _delay_ms(1);
        HDSP2000_C5_OFF;

        run++;
        asci=(run>>6)&0xf;

	}
}
